var Y=core.org.voxsoftware.Rtmp.Downloader
import Rtmp from './_rtmpdump'
import Path from 'path'
import Os from 'os'
var Fs= core.System.IO.Fs

class Channel{
	
	constructor(){
		this.server= new Y.Server()
	}
	
	init(){
		this.server.init()
	}

	getExecutablePath(){


		var path= process.env.PATH, p, f
		var paths= path.split(Path.sep)
		var win= Os.platform()=="win32"
		var osx= Os.platform()=="darwin"

		for(var i=0;i<paths.length;i++){

			p= paths[i]
			if(win){
				f= [
					Path.join(p, "rtmpdump.exe"),
					Path.join(p, "rtmpdump.bat")
				]
			}
			else{
				f=[Path.join(p, "rtmpdump")]
			}

			for(var y=0;y<f.length;y++){
				if(Fs.sync.exists(f[y]))
					return f[y]
			}

		}


		if(win){
			return Path.normalize(Path.join(__dirname, "..", "bin", "win/rtmpdump.exe"))
		}
		if(osx){
			return Path.normalize(Path.join(__dirname, "..", "bin", "osx/rtmpdump"))
		}

		return null
	}

	finalize(uid, err){
		if(!Channel.downloads[uid])
			return 


		Channel.downloads[uid].error= err
		Channel.downloads[uid].end= true

		var end= Channel.downloads[uid].emitend
		if(end)
			end()
	}

	getError(uid){
		if(!Channel.downloads[uid])
			return 

		return Channel.downloads[uid].error
	}


	startDownload(url){

		var task= new core.VW.Task()
		var uid= new Date().getTime().toString(36) + (++Channel.id).toString()
		var tmp= Path.join(Os.tmpdir(), uid), ended

		task.result= {
			uid
		}


		var options = {
		  rtmp: url,
		  v: null 
		}
		 
		var stream = Rtmp.createStream(options)
		stream.on('connected', function(info) {
		  // info provides various details about the stream 
		  // duration, resolution, codecs, ... 
		  console.log(info);
		});
		 
		stream.on('progress', function(kbytes, elapsed, percent) {
		  var p

		  if(percent>0){
		  	if(!ended){
			  	task.finish()
			  	ended=true
		  	}
		  }	  
		  p= {
		  	kbytes,
		  	elapsed,
		  	percent
		  }
		  Channel.downloads[uid].progress=p

		  if(Channel.downloads[uid].emitprogress)
		  	Channel.downloads[uid].emitprogress(p)


		})
		 
		stream.on('error', function(err) {
		  if(!ended){
		  	task.exception= err
		  	task.finish()
		  	ended= true
		  }

		  Channel.finalize(uid, err)

		})

		Channel.downloads[uid]={
			url: url, 
			uid: uid, 
			file: tmp, 
			emitprogress:null
		}

		var file= fs.createWriteStream(tmp)		 
		stream.pipe(file)
		file.on("finish", function(){
			Channel.finalize(uid)
		})
		return task

	}


	getDownloadLink(uid){
		return "http://127.0.0.1:"+this.server.port.toString()+"/download?uid="+encodeURIComponent(uid)
	}


}
Channel.id=0
Channel.downloads={}

export default Channel