
import {EventEmitter} from 'events'
var Fs= core.System.IO.Fs
var R= core.org.voxsoftware.Rtmp.Downloader


class Server extends EventEmitter{
	
	constructor(){
		var server= this.server= new core.VW.Http.Server()
		this.server.port=0
		this.server.timeout= 60000
		this.id=0
		
	}

	async init(){
		var server= this.server
		this.initServer()

		this.emit("init")
		await server.listen()

		this.emit("listen")
		//this.console.log("Proxy disponible: 127.0.0.1:", server.port)
		while(true){
			var reqArgs= await server.acceptAsync()
			this._continue(reqArgs);
		}
	}


	get port(){
		return this.server.port
	}

	async _continue(req){
		var time= new Date()
		var id= ++this.id
		req.id= id
		
		try{
			req.request.url=req.request.url.trim()
			//this.console.request(req.request.method, req.request.url, " ID: ", id)
			await req.catch(req.continue)
			//this.console.info("Solicitud completa: ", id, " Tiempo: ", new Date()-time, "ms")
		}
		catch(e){
			try{
				req.response.statusCode=500
				try{req.response.write(JSON.stringify({error:e.stack},4,'\t'));}catch(ex){}
				req.response.end()
			}
			catch(ex){}
		}
	}




	initServer(){
		var router= this.server.router
		router.get("/download", async (args)=>{

			var params= args.request.query
			var uid= params.uid, info
			if(!uid)
				throw new core.System.Exception("El uid es incorrecto")

			var download= R.Channel.downloads[uid]
			if(!download)
				throw new core.System.Exception("El uid es incorrecto")


			var readed= 0, buf= new Buffer(8120)
			var Stream= new core.System.IO.FileStream(download.file, core.System.IO.FileMode.Open, core.System.IO.FileAccess.Read)


			var name, url= download.url, ext
			url= url.split("/")
			name= url[url.length-1]
			ext= name.split(".")
			ext= ext[ext.length-1]
			name= "RTMPDownload." + ext


			args.response.writeHead(200, {
				"Content-disposition": "Attachment;filename=" + name
			})


			var Read= function(){
				var l= Stream.length, leido
				while(readed<l){
					leido= Stream.read(buf, 0, 8120)
					readed += leido
					args.response.write(buf.slice(0, leido))
				}
			}
			download.emitprogress= Read
			download.emitend= function(){
				args.response.end()
				Read=null
				try{
					Fs.sync.unlink(download.file)
				}
				catch(e){

				}
			}



		})
	}

}
export default Server